%define anolis_release 1
Summary: Fast compression and decompression utilities
Name: ncompress
Version: 5.0
Release: %{anolis_release}%{dist}

License: Public Domain
URL: https://github.com/vapier/%{name}
Source: https://github.com/vapier/%{name}/archive/refs/tags/v%{version}.tar.gz

# allow to build ncompress
# ~> downstream
Patch0: ncompress-5.0-make.patch

# from dist-git commit 0539779d937
# (praiskup: removed redundant part as -DNOFUNCDEF is defined)
# ~> downstream
Patch1: ncompress-5.0-lfs.patch

# exit when too long filename is given (do not segfault)
# ~> #unknown
# ~> downstream
# Patch2: ncompress-4.2.4.4-filenamelen.patch
# Did not segfault, Prints error 'File name too long'

# permit files > 2GB to be compressed
# ~> #126775
Patch3: ncompress-5.0-2GB.patch

# use memmove instead of memcpy
# ~> 760657
# ~> downstream
Patch4: ncompress-5.0-memmove.patch

# silence gcc warnings
# ~> downstream
# Patch6: ncompress-4.2.4.4-silence-gcc.patch
# Fixed with %ld and brackets are included

BuildRequires: make
BuildRequires: gcc
BuildRequires: glibc-devel

%description
The ncompress package contains the compress and uncompress file
compression and decompression utilities, which are compatible with the
original UNIX compress utility (.Z file extensions).  These utilities
can't handle gzipped (.gz file extensions) files, but gzip can handle
compressed files.

Install ncompress if you need compression/decompression utilities
which are compatible with the original UNIX compress utility.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep

%autosetup -n %{name}-%{version} -p2

%build
make CFLAGS="%{optflags} %{?nc_endian} %{?nc_align} %{build_ldflags}"

%install
mkdir -p $RPM_BUILD_ROOT/%{_bindir}
mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
install -p -m755 compress $RPM_BUILD_ROOT/%{_bindir}
ln -sf compress $RPM_BUILD_ROOT/%{_bindir}/uncompress
install -p -m644 compress.1 $RPM_BUILD_ROOT%{_mandir}/man1
ln -sf compress.1 $RPM_BUILD_ROOT%{_mandir}/man1/uncompress.1

%check
./tests/runtests.sh

%generate_compatibility_deps

%files
%dir %{abidir}
%{abidir}/compress-option.list
%{_bindir}/compress
%{_bindir}/uncompress
%{_mandir}/man1/*

%files doc
%doc LZW.INFO README.md

%changelog
* Sat Mar 25 2023 Heng Qi <hengqi@linux.alibaba.com> - 5.0-1
- Init package from upstream
